class BOMB
inherit
	TICKABLE
		redefine
			make,
			can_convey_me,
			can_push_me,
			player_touch
		end
	KNOWS_RAND
creation make, make_for_world
feature
	make(sq : SQUARE) is
	do
		Precursor(sq)
		put_chr(11)
	end

	can_convey_me : BOOLEAN is
	do
		Result := true
	end

	can_push_me(d : INTEGER) : BOOLEAN is
	do
		Result := true
	end

	read_init_rest(header : OBJECT_HEADER) is
	do
		ticks_left := header.p1
		if ticks_left >= 2 then
			put_chr(ticks_left + ('0').code)
		end
		ticker_off
	end

	ticks_left : INTEGER

	player_touch(p : PLAYER) is
	do
		if not exploding then
			put_chr(('9').code)
			ticks_left := 9
			square.map.tick_list.add_last(Current)
			ticker_on
			exploding := true
		else
			p.player_push
		end
	end

	exploding : BOOLEAN

	cycle_tick is
	do
		ticks_left := ticks_left - 1
		if ticks_left > 1 then
			put_chr(ticks_left + ('0').code)
		elseif ticks_left = 1 then
			phase1
			put_chr(11)
			cycle := 3 -- XXX: don't know what this should be
		else
			phase2
			die
		end
	end
	
	phase1 is
		--phase 1 of explosion
		--send blast to everything in radius and place breakable if possible
	local
		i, j : INTEGER
		x, y : INTEGER
		map : MAP
		br : BREAKABLE
		c : INTEGER
	do
		map := square.map
		from i := bomb_map.lower1
		until i > bomb_map.upper1
		loop
			from j := bomb_map.lower2
			until j > bomb_map.upper2
			loop
				x := i + square.location.x
				y := j + square.location.y
				if bomb_map.item(i, j) and then map.is_legal_coord(x, y) then
					map.board.item(x, y).dominant.blast
					if map.board.item(x, y).dominant.kind.is_equal("empty") then
						rand.next
						c := rand.last_integer(7)
						!!br.make(map.board.item(x, y))
						br.put_colour(c + 8)
					end
				end
				j := j + 1
			end
			i := i + 1
		end
	end

	phase2 is
		--phase 2 of explosion
		--remove all breakables in radius
	local
		i, j : INTEGER
		x, y : INTEGER
		map : MAP
		br : BREAKABLE
		c : INTEGER
	do
		map := square.map
		from i := bomb_map.lower1
		until i > bomb_map.upper1
		loop
			from j := bomb_map.lower2
			until j > bomb_map.upper2
			loop
				x := i + square.location.x
				y := j + square.location.y
				if bomb_map.item(i, j) and then map.is_legal_coord(x, y) then
					if map.board.item(x, y).dominant.kind.is_equal("breakable") then
						map.board.item(x, y).dominant.blast
					end
				end
				j := j + 1
			end
			i := i + 1
		end
	end

	bomb_map : ARRAY2[BOOLEAN] is
	local
		x, y : INTEGER
	once
		!!Result.make(-7, 7, -4, 4)
		from x := -7
		until x > 7
		loop
			from y := -4
			until y > 4
			loop
				Result.put(true, x, y)
				y := y + 1
			end
			x := x + 1
		end
		symmetric_clear(7, 4)
		symmetric_clear(6, 4)
		symmetric_clear(5, 4)
		symmetric_clear(7, 3)
		symmetric_clear(6, 3)
		symmetric_clear(7, 2)
		symmetric_clear(7, 1)
	end

	symmetric_clear(x, y : INTEGER) is
	do
		bomb_map.put(false, x, y)
		bomb_map.put(false, -x, y)
		bomb_map.put(false, x, -y)
		bomb_map.put(false, -x, -y)
	end

	kind : STRING is "bomb"
	zzt_code : INTEGER is 13
end
