class DUPLICATOR
inherit
	TICKABLE
		redefine make
		end
	DIRECTION
creation make, make_for_world
feature
	aim : INTEGER
	rate : INTEGER
	rate_count : INTEGER

	make(sq : SQUARE) is
	do
		Precursor(sq)
		put_chr(duplicator_chr.item(animation_cycle))
	end

	read_init_rest(header : OBJECT_HEADER) is
	local
	do
		rate := header.p2
		rate_count := 18
		aim := direction_from_xy(header.xstep, header.ystep)
	end

	animation_cycle : INTEGER

	cycle_tick is
	do
		rate_count := rate_count - 1
		if rate_count <= 2 * rate then
			rate_tick
			rate_count := 18
		end
	end
	rate_tick is
	do
		if animation_cycle = 4 then
			animation_cycle := 0
			duplicate
		else
			animation_cycle := animation_cycle + 1
		end
		put_chr(duplicator_chr.item(animation_cycle))
	end
	duplicate is
	local
		sq : SQUARE
		t, t2 : THING
	do
		sq := square.adjacent(aim)
		if not sq.dominant.kind.is_equal("sentinel") then
			t := sq.dominant
			sq := square.adjacent(opposite_direction(aim))
			if try_stay_push(opposite_direction(aim)) then
				t2 := t.instantiate(sq, t.colour)
			end
		end
	end

	duplicator_chr : ARRAY[INTEGER] is
	once
		!!Result.make(0, 4)
		Result.put(250, 0)
		Result.put(249, 1)
		Result.put(248, 2)
		Result.put(('o').code, 3)
		Result.put(('O').code, 4)
	end

	kind : STRING is "duplicator"
	zzt_code : INTEGER is 12
end
