class LINE
inherit
	WALL
		redefine make
		end
	DIRECTION
creation make, make_for_world
feature
	make(sq : SQUARE) is
	local
		i : INTEGER
	do
		Precursor(sq)
		!!line_flag.make(min_dir, max_dir)
		from i := min_dir
		until i > max_dir
		loop
			tell_neighbour(i)
			i := i + 1
		end
		compute_chr
	end

	tell_neighbour(dir : INTEGER) is
	local
		l : LINE
	do
		l := neighbour(dir)
		if l /= Void then
			l.compute_chr
		end
	end

	neighbour(dir : INTEGER) : LINE is
	local
		sq : SQUARE
	do
		sq := square.adjacent(dir)
		if sq /= Void then
			if sq.dominant = Void then
				io.put_string("Uh oh: bug in line%N")
				die_with_code(1)
				--this is most unusual
				--and probably shouldn't happen
			end
			Result ?= sq.dominant
		end
	end

	compute_chr is
	local
		i : INTEGER
		l : LINE
	do
		from i := min_dir
		until i > max_dir
		loop
			l := neighbour(i)
			if l /= void then
				line_flag.put(true, i)
			else
				line_flag.put(false, i)
			end
			i := i + 1
		end
		if line_flag.item(north) then
			if line_flag.item(south) then
				if line_flag.item(east) then
					if line_flag.item(west) then
						put_chr(206)
					else
						put_chr(204)
					end
				else
					if line_flag.item(west) then
						put_chr(185)
					else
						put_chr(186)
					end
				end
			else
				if line_flag.item(east) then
					if line_flag.item(west) then
						put_chr(202)
					else
						put_chr(200)
					end
				else
					if line_flag.item(west) then
						put_chr(188)
					else
						put_chr(208)
					end
				end
			end
		else
			if line_flag.item(south) then
				if line_flag.item(east) then
					if line_flag.item(west) then
						put_chr(203)
					else
						put_chr(201)
					end
				else
					if line_flag.item(west) then
						put_chr(187)
					else
						put_chr(210)
					end
				end
			else
				if line_flag.item(east) then
					if line_flag.item(west) then
						put_chr(205)
					else
						put_chr(198)
					end
				else
					if line_flag.item(west) then
						put_chr(181)
					else
						put_chr(249)
					end
				end
			end
		end
	end

	line_flag : ARRAY[BOOLEAN]

	kind : STRING is "line"
	zzt_code : INTEGER is 31
end
