class PLAYER
inherit
	MONSTER_OBJECT
		redefine
			make,
			shot,
			blast,
			move_to,
			can_push_me,
			can_convey_me
		end
	KNOWS_MASTER
	DIRECTION
creation make
feature
	read_init(header : OBJECT_HEADER) is
	do
	end

	make(sq : SQUARE) is
	do
		Precursor(sq)
		put_chr(2)
		put_colour(31)
		!!stat_table.make
		make_stat("gems")
		make_stat("ammo")
		make_stat("torches")
		make_stat("health")
		make_stat("score")
	end

	--not used yet
	make_stat(s : STRING) is
	require
		not has_stat(s)
	do
		stat_table.put(0, s)
	end
	
	has_stat(s : STRING) : BOOLEAN is
	do
		Result := stat_table.has(s)
	end

	stat(s : STRING) : INTEGER is
	require
		has_stat(s)
	do
		Result := stat_table.at(s)
	end

	put_stat(s : STRING; amount : INTEGER) is
	require
		has_stat(s)
	do
		stat_table.put(amount, s)
	end

	add_stat(s : STRING; amount : INTEGER) is
	require
		has_stat(s)
	do
		stat_table.put(stat_table.at(s) + amount, s)
	end

	gems : INTEGER
	put_gems(i : INTEGER) is
	do
		gems := i
	end
	add_gems(i : INTEGER) is
	do
		gems := gems + i
	end

	ammo : INTEGER
	put_ammo(i : INTEGER) is
	do
		ammo := i
	end
	add_ammo(i : INTEGER) is
	do
		ammo := ammo + i
	end

	health : INTEGER
	put_health(i : INTEGER) is
	do
		health := i
	end
	add_health(i : INTEGER) is
	do
		health := health + i
	end

	score : INTEGER
	put_score(i : INTEGER) is
	do
		score := i
	end
	add_score(i : INTEGER) is
	do
		score := score + i
	end

	torch : INTEGER
	put_torch(i : INTEGER) is
	do
		torch := i
	end
	add_torch(i : INTEGER) is
	do
		torch := torch + i
	end

	keys : ARRAY[BOOLEAN]

	init(w : WORLD) is
	do
		put_ammo(w.start_ammo)
		put_health(w.start_health)
		put_gems(w.start_gems)
		put_torch(w.start_torch)
		put_score(w.start_score)
		keys := w.start_keys
	end

	send_player_touch(d : INTEGER) is
	local
		i : INTEGER
	do
		direction := d
		square.world_adjacent(direction).dominant.player_touch(Current)
	end

	send_player_touch_square(sq : SQUARE) is
	local
		i : INTEGER
	do
		sq.dominant.player_touch(Current)
	end

	goto_board(destination : INTEGER) is
	do
		dungeon_master.zzt.goto_board(destination)
	end

	passage_to(destination, passage_colour : INTEGER) is
	do
		dungeon_master.zzt.passage_to(destination, passage_colour)
	end

	can_push_me(d : INTEGER) : BOOLEAN is
	do
		Result := true
	end

	can_convey_me : BOOLEAN is true

	player_push is
	local
		sq : SQUARE
	do
		sq := square.world_adjacent(direction)
		if sq.dominant.try_push(direction) then
			move_to(sq)
		end
	end

	kind : STRING is "player"
	zzt_code : INTEGER is 4

	move_to(destination_square : like square) is
	do
		dungeon_master.zzt.board_change_check(destination_square.map)
		Precursor(destination_square)
	end

	hurt is
	do
		add_health(-10)
		if health < 0 then
			put_health(0)
		end
	end

	shot(b : BULLET) is
	do
		hurt
	end

	blast is
	do
		hurt
	end

feature {NONE}
	stat_table : DICTIONARY[INTEGER, STRING]
end
