class TRANSPORTER
inherit
	DIRECTION
	TICKABLE
		redefine
			player_touch
		end
creation make, make_for_world
feature
	aim : INTEGER

	read_init_rest(header : OBJECT_HEADER) is
	do
		aim := direction_from_xy(header.xstep, header.ystep)
		put_chr(transporter_chr.item(aim, animation_cycle))
		animation_cycle := 0
	end

	animation_cycle : INTEGER

	cycle_tick is
	do
		if animation_cycle = 3 then
			animation_cycle := 0
		else
			animation_cycle := animation_cycle + 1
		end
		put_chr(transporter_chr.item(aim, animation_cycle))
	end

	player_touch(p : PLAYER) is
	local
		done : BOOLEAN
		dest : SQUARE
		t : TRANSPORTER
	do
		if p.direction = aim then
			dest := square.adjacent(aim)
			if dest.dominant.can_walk_on then
				--first preference: square directly beyond transporter
				done := true
			else
				from
				until done or else dest.dominant.kind.is_equal("sentinel")
				loop
					if dest.dominant.kind.is_equal("transporter") then
						t ?= dest.dominant
						if t.aim = opposite_direction(aim) then
							--right type of transporter
							--we only need the square beyond to be free now
							dest := dest.adjacent(aim)
							if dest.dominant.can_walk_on then
								done := true
							end
						else
							dest := dest.adjacent(aim)
						end
					else
						dest := dest.adjacent(aim)
					end
				end
			end
			if done then
				p.move_to(dest)
			end
		end
	end

	kind : STRING is "transporter"
	zzt_code : INTEGER is 30

	transporter_chr : ARRAY2[INTEGER] is
	once
		!!Result.make(min_dir, max_dir, 0, 3)
		Result.put(('-').code, north, 0)
		Result.put(('^').code, north, 1)
		Result.put(('~').code, north, 2)
		Result.put(('^').code, north, 3)

		Result.put(('_').code, south, 0)
		Result.put(('v').code, south, 1)
		Result.put(('-').code, south, 2)
		Result.put(('v').code, south, 3)

		Result.put(179, east, 0)
		Result.put((')').code, east, 1)
		Result.put(('>').code, east, 2)
		Result.put((')').code, east, 3)

		Result.put(179, west, 0)
		Result.put(('(').code, west, 1)
		Result.put(('<').code, west, 2)
		Result.put(('(').code, west, 3)
	end
end
